import {Resource} from '@modal-sh/yasumi';
import {RequestDecorator} from '@modal-sh/yasumi/backend';

declare module '@modal-sh/yasumi/backend' {
	interface RequestContext {
		resource?: Resource;
		resourceId?: string;
	}
}

export const decorateRequestWithResource: RequestDecorator = (req) => {
	const [, resourceRouteName, resourceId] = req.url?.split('/') ?? [];
	const resource = Array.from(req.backend.app.resources)
		.find((r) => r.state.routeName === resourceRouteName) as Resource | undefined;

	if (typeof resource !== 'undefined') {
		req.backend.dataSource.prepareResource(resource);
		req.resource = resource;
		if (resourceId?.trim().length > 0) {
			req.resourceId = resourceId;
		}
	}

	return req;
};
